function PlayerController(id,can_be_master){
	var self = this; self.name = "PlayerController"; // MANDATORY

    this.dataManager = new DataManagerController();
    this.keyboard = new KeyboardController(self);
    this.userInterface = false;
    this.on_screen_alert = new OnScreenAlertController();

    this.renderer = null;
    this.playlist = false; // PlaylistController || TimelineController
		this.config = null;
    this.schedule = false;

    this.file_timestamp = -1;
    this.timestamp = -1;
    this.actual_dow = -1;

    this.timer = 0;

    this.registered = true;
    this.registerWindowFailRef = 666;
    this.registerWindowRegisteringRef = 777;
    this.registerWindowActivationRef = 888;
    this.alertWindowRef = 999;
    this.check_interval = 1000;

    this.scene = false;
    this.rendering = false;
		this.displayOrientation = "landscape";

    this.info_window = $('<div id="info-'+Date.now()+'" class="info">info not available yet</div>');
    this.log_window = $('<div id="log-'+Date.now()+'" class="log"></div>');
    this.ui = $('<div id="ui-'+Date.now()+'" class="ui-main"></div>');

		this.beat_timer = 0;
		this.id = 0;
		this.player_id = 0;

		this.can_be_master = true;

		if(typeof(id) !== "undefined"){
			this.player_id = id;
		}
		if(typeof(can_be_master) !== "undefined"){
			if(!can_be_master){
				this.can_be_master = false;
			}
		}
		this.api_content_volume = -1;
		this.socket_volume = -1;

		this.core_setup_window_showing = false;
		this.proxy_setup_window_showing = false;

		this.init = function(base_path,force_platform){
				//var test = this.isgoingtofail(); // <-- MAKE PLAYER FAIL !! TEST !!!
        if(typeof(base_path) != "undefined"){
            self.ROUTES['BASE'].path = base_path;
        }
				self.setPlatform(force_platform);
        self.log("initialize OS ... "+self.OS.name);

        self.OS.init(self.start);
		};

    this.start = function(){
				self.log("Player version "+self.version+" Started at : "+self.getDate());
				self.notifyError(self.ERROR['PLAYER_CONTROLLER']+9,self.name+": Player version "+self.version+" Started at : "+self.getDate());
				if(typeof(LOADED_WITH_MISSING_SCRIPTS) != "undefined"){
					if(LOADED_WITH_MISSING_SCRIPTS){
						self.notifyError(self.ERROR['PLAYER_CONTROLLER']+666,self.name+": LOADED_WITH_MISSING_SCRIPTS !!! Some scripts are missing or corrupt !");
						self.OS.systemRepairUpdate();
					}
				}
				// PREPARE DISPLAY
				var display = $('<div id="stage-'+Date.now()+'" class="stage '+self.platform+' '+self.displayOrientation+'"></div>');

				$("body").append(display);
				display.append(self.info_window);
				display.append(self.log_window);
				display.append(self.ui);
				self.setInfoWindow(self.info_window);
				self.ui.on("click",self.onStageClick);
				self.log("Singleton Version : "+self.version);

				var emergency_content = self.dataManager.createArchiveFileItem(0,self.ROUTES['STYLE'].path+"logo.svg",3);
				emergency_content.relative_path = true;

				self.renderer = new DisplayController(display);
				self.userInterface = new UserInterfaceController(self.ui);
				self.renderer.init(emergency_content,self.userInterface);

        if(self.platform == "WEB"){
            self.loadXmlURL(self.ROUTES['BASE'].path+self.ROUTES['CONFIG'].path,self.initialConfig);
        }else if(self.platform == "SOC" || self.platform == "BRIGHT"){
            self.OS.readFile(self.ROUTES['CORE'].path,self.initialCore);
        }else{
            self.loadXmlURL(self.OS.rootDir+self.ROUTES['CORE'].path,self.initialCore);
        }
        if(self.beat_timer == 0){
				  self.beat();
				}
				$('.stage').css('cursor', 'none');

				try{
					self.OS.moveFile("app_backup/proxy.json",self.ROUTES['PROXY_CONF'].path,function(ok){
						self.OS.readFile(self.ROUTES['PROXY_CONF'].path,function(data){
							var reverse_proxy_conf = false;
							try{
								reverse_proxy_conf = JSON.parse(data);
								self.OS.api_connector.setProxyOptions(reverse_proxy_conf);
								self.OS.setProxyConfig(reverse_proxy_conf);
								self.log("USING PROXY ! ");
		          }catch(e){
		            self.log("NOT USING PROXY ---- No Valid Proxy Config found : ");
									self.log(data);
							}
						});
					});
				}catch(e){
					console.log("Something went wrong when trying to get proxy.json info");
				}
				try{
					self.OS.SocketConnector.setWhoAmI(self.name);
				}catch(e){
					console.log(e);
				}
				if(self.platform === "ANDROID"){
					self.OS.writeFile("admira.out","0");
				}

				if(self.platform == "WIN" || self.platform == "MAC" || self.platform == "LINUX"){
					try{
						self.OS.readFile("./package.json",function(data){
							if(data.lastIndexOf("auto-select-desktop-capture-source") < 0){
								if(window.navigator.language == "en-GB" || window.navigator.language == "en-US"){
						      data = data.replace("--ignore-gpu-blacklist","--ignore-gpu-blacklist --auto-select-desktop-capture-source='Entire screen'");
						    }else{
						      data = data.replace("--ignore-gpu-blacklist","--ignore-gpu-blacklist --auto-select-desktop-capture-source='Toda la pantalla'");
						    }
								self.OS.writeFile("./package.json",data,function(ok){
									if(ok){
										self.log("Write auto-select-desktop-capture-source flag OK.");
										self.OS.reload();
									}else{
										self.log("Unable to write auto-select-desktop-capture-source flag.");
									}
								});
							}else{
								self.log("Already has auto-select-desktop-capture-source flag.");
							}
						});
					}catch(e){
						self.log("Already has auto-select-desktop-capture-source flag.");
					}
				}
    };

	this.beat = function(){
				if(self.is_child){
					self.log("Child Beat !");
				}else{
					self.log("Beat !");
				}
				if(self.platform == "ANDROID"){

	        var time = self.getDate().getTime();
	        time = parseInt(time/1000);
	        self.OS.writeFile("admira.beat",""+time);
				}
				try{
					self.content_api.updateInfo(self.name,self.getInfo());
				}catch(e){
					console.log(e);
				}
				clearTimeout(self.beat_timer);
				setTimeout(self.beat,7000);
    };

    this.onStageClick = function(){
        try{
            if(self.registered){
                if(self.config){
                    if(self.config.getQuitOnClickOption()){
                        self.OS.quit();
                    }
                }
            }
        }catch(e){
            self.log("Could not find QuitOnClick option in config tag.");
        }finally{
            self.log("Could not exit App");
        }
    };

    this.loadXmlURL = function(url,callback){
        var xhr = new XMLHttpRequest();
        url = url+"?"+Date.now();
        xhr.open("GET", url, true);
        xhr.setRequestHeader("Content-Type", "text/xml");
        xhr.addEventListener("load", function () {
            if (xhr.status === 200
								|| (xhr.status === 0 && self.platform == "BRIGHT")
								|| (xhr.status === 0 && self.platform == "ONLINE")
								|| (xhr.status === 0 && self.platform == "WEB")
                || (xhr.status === 0 && self.platform == "WEBOS")
                || (xhr.status === 0 && self.platform == "MAC")
                || (xhr.status === 0 && self.platform == "LINUX")
                || (xhr.status === 0 && self.platform == "TIZEN")
                || (xhr.status === 0 && self.platform == "WIN")
                || (xhr.status === 0 && self.platform == "ANDROID")
                || (xhr.status === 0 && self.platform == "IOS")) {
                self.log("Loaded : "+url);
                callback(xhr.response);
            }
        }, false);
        xhr.addEventListener("progress", function (e) {
            if(e.lengthComputable){
                var percent = (e.loaded / e.total) * 100;
                self.log(percent+" % of "+e.total+" bytes");
            }
        }, false);
        xhr.addEventListener("error", function (e) {
            self.log("XML Loading Error for: "+url);
            self.notifyError(self.ERROR['PLAYER_CONTROLLER']+1,self.name+": Function loadXmlURL() failed : could not load XML");
            callback();
        }, false);
        xhr.send();
    }

    this.initialCore = function(data){
        self.setAPIroutes(data,self.player_id);
				if(self.player_id == 0){
					self.player_id = self.core_id
					self.is_child = false;
				}else{
					self.is_child = true;
				}
				self.OS.sync_master_supported = self.can_be_master;
				self.ROUTES['CORE'].exists = true;
        if(self.platform == "SOC"){
						clearTimeout(self.timer);
            self.timer = setTimeout(self.getWeekTimestampFromFile,self.check_interval);
        }else{
            self.loadXmlURL(self.OS.rootDir+self.ROUTES['CONFIG'].path,self.initialConfig);
        }
				self.content_api.updateInfo(self.name,self.getInfo());
				$(self.content_api).on("ApiContentConditionSet",self.onApiContentConditionSet);
				$(self.content_api).on("ApiContentReadFile",self.onApiContentReadFile);
				$(self.content_api).on("ApiContentWriteFile",self.onApiContentWriteFile);
				$(self.content_api).on("ApiContentAnalytic",self.onApiContentAnalytic);
				$(self.content_api).on("ApiContentAppQuit",self.onApiContentAppQuit);
				$(self.content_api).on("ApiContentMainDuration",self.onApiContentMainDuration);
				$(self.content_api).on("ApiContentGetPlayerInfo",self.onApiContentGetPlayerInfo);
				$(self.content_api).on("ApiContentPreloadNext",self.onApiContentPreloadNext);
				$(self.content_api).on("ApiContentSendLog",self.onApiContentSendLog);
				$(self.content_api).on("ApiContentSendNotify",self.onApiContentSendNotify);
				$(self.content_api).on("ApiContentDeleteFile",self.onApiContentDeleteFile);
				$(self.content_api).on("ApiContentOsFunction",self.onApiContentOsFunction);
				$(self.content_api).on("ApiContentSetVolume",self.onApiContentSetVolume);
				$(self.content_api).on("ApiContentSetPlayStatus",self.onApiContentSetPlayStatus);
				$(self.content_api).on("ApiSocketSetVolume",self.onSocketSetVolume);
				$(self.content_api).on("ApiContentGetVolume",self.onApiContentGetVolume);
				$(self.content_api).on("ApiContentSetAudioConfig",self.onApiContentSetAudioConfig);

				$(window).on("SystemControllerConnectionChange",self.onSystemControllerConnectionChange);
    };

    this.initialConfig = function(data){
        self.setPaths(data);
				if(self.platform == "WEB" || self.platform == "ONLINE"){
					try{
						if(typeof(data) !== "undefined"){
							var parser=new DOMParser();
							var xmlDoc=parser.parseFromString(data,"text/xml");
							var start_ui = Boolean(parseInt(xmlDoc.getElementsByTagName("params")[0].getAttribute('controls')));
							var start_muted = Boolean(parseInt(xmlDoc.getElementsByTagName("params")[0].getAttribute('muted')));
							if(start_ui){
								self.userInterface.activate();
							}
							if(start_muted){
								self.setVolume(0);
							}
						}
					}catch(e){
						console.log(e);
					}
				}
				clearTimeout(self.timer);
				if(self.platform == "ONLINE"){
					self.OS.saveCoreFile(self.core_id,self.api_ver,self.api_url,function(ok){
						console.log("ONLINE SAVED New Core : "+ok);
					});
					self.timer = setTimeout(self.getWeekTimestampFromXMLData,self.check_interval);
				}else{
	        self.timer = setTimeout(self.getWeekTimestampFromXML,self.check_interval);
				}
    };

    this.update = function(){
        if(self.platform == "WEB"){
            self.loadXmlURL(self.ROUTES['BASE'].path+self.ROUTES['CONFIG'].path);
            self.file_timestamp = -1;
            self.timestamp = -1;
        }else{
            self.file_timestamp = -1;
            self.timestamp = -1;
            self.dataManager.load(self.getDataUrl(),self.timestamp);
        }
    };

    this.getDataUrl = function(){
        var dow = self.getDayOfWeek();
        if(dow != self.actual_dow){
            self.actual_dow = dow;
            self.timestamp = -1;
            self.file_timestamp = -1;
        }
				var url = self.ROUTES['XML'].path+dow+".xml";
				if(self.is_child){
					url = self.ROUTES['XML'].path+self.player_id+"_"+dow+".xml";
				}
				//self.log("Loading XML data from : "+url);
        if(self.platform == "WEB" || self.platform == "ONLINE"){
            url = self.ROUTES['DATA'].path;
        }else{
            self.ROUTES['DATA'].path = url;
        }
        return url;
    };

    this.onDataLoaded = function(e){
				if(self.content_api){
					self.content_api.broadcastApiContentEvent(self.content_api.API_XML,true);
				}
        $(self.dataManager).off("DataManagerControllerDataLoaded",self.onDataLoaded);
        var new_timestamp = self.dataManager.getTimestamp();
        self.log("XML Data Loaded with Timestamp : "+new_timestamp +" Last Stamp :"+self.timestamp);
        if(self.timestamp != new_timestamp){
            self.timestamp = new_timestamp;
            self.loadConfiguration();
            self.registered = self.checkRegister();
            if(self.registered){
                var needs_init = true;
                var new_playlist = self.dataManager.getPlaylistType();
                if(!self.playlist){
                    if(new_playlist == "PlaylistController"){
                        self.playlist = new PlaylistController(self.player_id);
                        self.playlist.setRenderer(self.renderer);
                        $(self.playlist).one("PlaylistControllerReady",self.onPlaylistReady);
                        $(self.playlist).on("PlaylistControllerInvalidPlaylist",self.onInvalidPlaylist);
                    }else if(new_playlist == "TimelineController"){
                        self.playlist = new TimelineController(self.player_id);
                        self.playlist.setRenderer(self.renderer);
                        $(self.playlist).one("TimelineControllerReady",self.onPlaylistReady);
                        $(self.playlist).on("TimelineControllerInvalidPlaylist",self.onInvalidPlaylist);
                        $(self).on("SystemTimeUpdate",self.playlist.onSystemTimeUpdate);
                    }
                }else{
                    if(self.playlist.name != new_playlist){
                        $(self).off("SystemTimeUpdate",self.playlist.onSystemTimeUpdate);
                        self.playlist.unload();
                        self.playlist = null;
                        if(new_playlist == "PlaylistController"){
                            self.playlist = new PlaylistController(self.player_id);
                            self.playlist.setRenderer(self.renderer);
                            $(self.playlist).one("PlaylistControllerReady",self.onPlaylistReady);
                            $(self.playlist).on("PlaylistControllerInvalidPlaylist",self.onInvalidPlaylist);
                        }else if(new_playlist == "TimelineController"){
                            self.playlist = new TimelineController(self.player_id);
                            self.playlist.setRenderer(self.renderer);
                            $(self.playlist).one("TimelineControllerReady",self.onPlaylistReady);
                            $(self.playlist).on("TimelineControllerInvalidPlaylist",self.onInvalidPlaylist);
                            $(self).on("SystemTimeUpdate",self.playlist.onSystemTimeUpdate);
                        }
                    }else{
                        needs_init = false;
                    }
                }
								self.renderer.checkAvailability(self.renderer.default_ref,0,function(exists){
									if(exists){
										self.log("Start with content transition : "+self.renderer.default_ref);
									}else{
										self.log("Start without content transition .... does not exists yet");
									}
									if(self.playlist){
										self.playlist.update(self.dataManager);
		                if(needs_init){
												self.renderer.clear();
												self.playlist.start();
												$('body').css('background-image', 'none');
		                }else{
											var jump = self.config.getAdvancedPlaylistJump();
											if(jump){
												if(self.playlist){
													if(self.playlist.active){
														self.log("XML Updated ... jump playlist forced");
														self.playlist.jump();
													}
												}
											}
										}
									}else{
										self.log("No Playlist found ... assuming MultiPlayer Parent");
									}
								});

            }else{
                if(self.playlist){
                    $(self.playlist).off("PlaylistControllerReady",self.onPlaylistReady);
                    self.playlist.stop();
                    self.playlist = null;
                    self.playlist = false;
                }else{
									self.log("No Playlist found ... assuming MultiPlayer Parent");
								}
            }
        }
				if(self.config){
            self.check_interval = self.config.getSystemRefreshTime()*1000;
        }
				clearTimeout(self.timer);
        if(self.platform == "SOC"){
            self.timer = setTimeout(self.getWeekTimestampFromFile,self.check_interval);
				}else if(self.platform == "ONLINE"){
						self.timer = setTimeout(self.getWeekTimestampFromXMLData,self.check_interval);
        }else{
            self.timer = setTimeout(self.getWeekTimestampFromXML,self.check_interval);
        }
        $(self).trigger("PlayerDataLoaded");
    };

    this.checkRegister = function(){
        if(self.platform == "WEB"){return true;}
        var api = self.execute(function(){return self.config.getApiKey();});
		self.setApiKey(api)
        var activated = self.execute(function(){ return self.config.getActivationStatus();});

        var domain = self.execute(function(){ return self.config.getDomain();});

        if(!domain || domain == ""){
            domain = self.defaultDomain;
        }

        self.renderer.cancel_all(self.registerWindowFailRef,self.renderer.default_layer,true);
        self.renderer.cancel_all(self.registerWindowRegisteringRef,self.renderer.default_layer,true);
        self.renderer.cancel_all(self.registerWindowActivationRef,self.renderer.default_layer,true);
        if(activated){
            self.log("Player is registered with API KEY = "+api);
            return true;
        }else if(api){
            self.log("Player needs activation for API KEY = "+api);
            var register_content = self.dataManager.createArchiveFileItem(self.registerWindowActivationRef,"http://"+domain+"/register/registered/"+api,-1);
            register_content.relative_path = true;
            register_content.force_http_source = true;
            self.renderer.addDisplayElement(register_content);
            $(self.renderer).on("DisplayControllerElementError",self.registrationSystemFail);
            self.scene = self.renderer.prepare_scene(false,register_content.getId(),false);
            self.rendering = self.renderer.render_scene(self.scene,self.rendering);
            return false;
        }else{
            self.log("Player is initiating the registration process");
            var register_content = self.dataManager.createArchiveFileItem(self.registerWindowRegisteringRef,"http://"+domain+"/register/",-1);
            register_content.relative_path = true;
            register_content.force_http_source = true;
            self.renderer.addDisplayElement(register_content);
            $(self.renderer).on("DisplayControllerElementError",self.registrationSystemFail);
            self.scene = self.renderer.prepare_scene(false,register_content.getId(),false);
            self.rendering = self.renderer.render_scene(self.scene,self.rendering);
            return false;
        }
    };

    this.registrationSystemFail = function(e){
        $(self.renderer).off("DisplayControllerElementError",self.registrationSystemFail);
        var register_content = self.dataManager.createArchiveFileItem(self.registerWindowFailRef,self.ROUTES['STYLE'].path+"register_failed.html",-1);

        register_content.relative_path = true;
        self.renderer.addDisplayElement(register_content);
        self.scene = self.renderer.prepare_scene(false,register_content.getId(),false);
        self.rendering = self.renderer.render_scene(self.scene,self.rendering);

        self.notifyError(self.ERROR['PLAYER_CONTROLLER']+2,self.name+": Function registrationSystemFail() failed");
				setTimeout(function(){
					self.toggleCoreSetupWindow();
				},5000);
    };

    this.loadEvents = function(){
        var onScreenAlertsConfig = self.config.getOnScreenAlertsConfig();
        if(onScreenAlertsConfig){
            self.log("Checking onScreenAlerts ... ");
            self.on_screen_alert.update(onScreenAlertsConfig.url,onScreenAlertsConfig.interval,onScreenAlertsConfig.send_id);
            $(self.on_screen_alert).on("OnScreenAlertUpdate",self.onScreenAlertUpdate);
        }else{
            self.log("Disable check onScreenAlerts.");
            self.on_screen_alert.stop();
        }
    };

    this.loadConfiguration = function(){
        self.config = self.dataManager.getConfig();
        self.log("Loading Configuration for Player Id : "+self.config.getId());
				if(self.platform != "WEB"){
					if(self.api_content_volume < 0){
						if(self.socket_volume < 0){
							self.setVolume(self.config.getVolume());
							self.log("Using Volume : "+self.config.getVolume());
						}
						else{
							self.log("Using socket Volume : "+self.socket_volume);
						}
					}else{
						self.log("Using ApiContent Volume : "+self.api_content_volume);
					}
	      }
				try{
					self.OS.alwaysOnTop(self.config.getAlwaysOnTop());
					if(self.platform != "WEB"){
						self.activateLogger(self.config.getDebugMode());
					}
					if(self.platform == "ANDROID"){
						if(self.config.getAlwaysOnTop()){
							self.OS.writeFile("always_on_top.info","1");
						}else{
							self.OS.writeFile("always_on_top.info","0");
						}
					}

	        // REALLY NEEDED ?
	        //self.schedule = self.config.getScheduleConfig();

	        var dow = self.getDayOfWeek();
	        var date = self.getDate();
	        var check =((dow-1)*24) + date.getHours();
	        self.log("(Compare with transfer) Checking for day of week : "+dow+" on hour : "+date.getHours()+" Check hour of the week : "+check);

					// SMOOTHING NEEDS PLAYER REBOOT AFTER APPLIED
	        self.renderer.setVideoProperties(self.config.getAdvancedVideoSmoothing(),self.config.getAdvancedVideoDeblocking());

	        var defaultContent = self.dataManager.getArchiveFileItemById(self.config.getDefaultContent());
	        defaultContent = self.execute(function(){return defaultContent;});
	        self.renderer.modifyEmergencyContent(defaultContent);

	        var info = self.config.getPlayerInfo();
	        self.infoName = info.name;

					self.setPlayerWindow();

					var text_size = 20;
					if(parseInt(self.renderer.w) > 1024){text_size = 50;}
					var html_info_img = "<img src='"+self.ROUTES["STYLE"].path+"/admira_app_icon.png' style='z-index:-1;position:absolute;top:20px;right:20px;width:80px;height:80px'>";
					var html_info = "<span style='text-align:center;font-size:"+text_size+"px;color:#FFF;background-color:#000'>Key : "+info.api_key.substring(0,10)+" "+info.api_key.substring(11,20)+" "+info.api_key.substring(21,30)+" "+info.api_key.substring(31,40);
	        html_info += " </span><br><span style='color:#FFF;background-color:#000'>V : "+self.version+" ID : "+info.id+" Project : "+info.project+"<br>Name : "+info.name+"</span>";
					self.info_window.html(html_info);

					self.log("My core ID is : "+self.core_id);
					if(self.core_id == "0"){
						self.log("Setting Core ID from XML file ... "+self.config.getId());
						self.setCoreId(self.config.getId());
						self.log("No my Core ID is : "+self.core_id);
						self.log("This Core ID is : "+this.core_id);
						if(self.platform == "ONLINE"){
							self.OS.saveCoreFile(self.core_id,self.api_ver,self.api_url,function(ok){
								console.log("ONLINE SAVED New Core : "+ok);
							});
						}
        	}
				}
				catch(e){
					self.log(e);
				}
				try{
					self.loadEvents();
				}catch(e){
					self.log("Could not execute loadEvents() ");
				}
				try{
					self.content_api.updateInfo(self.name,self.getInfo());
				}catch(e){
					self.log("Unable to updateInfo for stats_type");
				}
				try{
					self.getMediaDevices(function(audio_devices){
						self.OS.audio_devices = audio_devices;
					});
				}catch(e){
					self.log("Could not get Media Devices");
				}

				try{
					var remote_setted_devices = self.dataManager.getDevices();
					var foundAudioDriver = false;
					var count = 0;
					var selected_volume = self.volume;
					if(self.audioController){
						try{
							self.audioController.resetDefaultAudioOptions(selected_volume);
						}catch(e){
							console.log("Failed to restart Default Audio Settings");
						}
					}
					for(var i=0;i<remote_setted_devices.length;i++){
						if(remote_setted_devices[i].model == 65){
							foundAudioDriver = true;
							try{
								self.updateAudioController(false);
							}catch(e){
								console.log("Failed to Load AudioDriver");
								console.log(e);
							}

							try{
								selected_volume = remote_setted_devices[i].volume;
								if(selected_volume == -1){
									selected_volume = self.volume;
								}
							}catch(e){
								console.log(e);
							}
							var options = undefined;
							try{
								var options = {'internal_id':remote_setted_devices[i].id,'deviceId':""+remote_setted_devices[i].port,'channel':remote_setted_devices[i].remote_id,'gain':selected_volume};

							}catch(e){
								console.log("Failed to GET OPTIONS");
								console.log(e);
							}
							try{
								self.audioController.addAudioConfig(options);
							}catch(e){
								console.log("Failed to Adding AudioConfig");
								console.log(e);
							}
							if(count == 0){
								try{
									self.audioController.setDefaultAudioOptions(options);
								}catch(e){
									console.log("Failed to SET OPTIONS");
									console.log(e);
								}
							}
							count++;
						}
					}
					if(!foundAudioDriver && self.audioController){
						try{
							self.updateAudioController(true);
						}catch(e){
							console.log("Failed to Unload AudioDriver");
							console.log(e);
						}
					}

				}catch(e){
					console.log("Failed to load : remote_setted_devices");
					console.log(e);
				}

				try{
					if(self.platform == "ANDROID" || self.platform == "LINUX" || self.platform == "WIN" || self.platform == "MAC"){
						if(self.config.getMode() == 1){
							$("body").css("background","transparent");
						}else{
							$("body").css("background","#000");
						}
					}
				}catch(e){
					console.log(e);
				}
    };

		this.setPlayerWindow = function(){
			if(self.config){
				var screen = self.config.getScreenConfig();
				if(screen.w == "100%"){
					screen.w = window.innerWidth;
					if(self.platform == "ANDROID"){
						if(typeof(window.screen.width) !== "undefined"){
							screen.w = window.screen.width;
						}
					}
				}
				if(screen.h == "100%"){
					screen.h = window.innerHeight;
					if(self.platform == "ANDROID"){
						if(typeof(window.screen.height) !== "undefined"){
							screen.w = window.screen.width;
						}
					}
				}

				if(screen.x != 0 || screen.y != 0){
					// WHY ????
					if(self.platform == "WIN" || self.platform == "LINUX" || self.platform == "MAC"){
						screen.x = 0;
						screen.y = 0;
					}
				}
				self.renderer.modifyViewer(screen.x,screen.y,screen.w,screen.h);
			}
		};

    this.onPlaylistReady = function(e){
        e.currentTarget.log("Info : Playlist is Ready");
        //self.loadEvents();
    };

    this.onScreenAlertUpdate = function(e){
        if(typeof(e.currentTarget.active_alert) != "undefined"){
            var active_alert = e.currentTarget.active_alert;
            if(active_alert != ""){
                self.log("Put on Screen Alert = "+active_alert);
                //if(self.playlist.active){
                    self.playlist.stop();
                    var alert_content = self.dataManager.createArchiveFileItem(self.alertWindowRef,active_alert,-1);
                    alert_content.relative_path = true;
                    alert_content.force_http_source = true;
                    self.alertWindowRef = self.renderer.addDisplayElement(alert_content);
                    $(self.renderer).on("DisplayControllerElementError",function(){
                        $(self.renderer).off("DisplayControllerElementStarted");
                        $(self.renderer).off("DisplayControllerElementError");
                        self.log("Unloading onScreenAlert.");
                        if(!self.playlist.active){
                            self.playlist.start();
                        }
                    });
                    $(self.renderer).on("DisplayControllerElementStarted",function(){
                        $(self.renderer).off("DisplayControllerElementStarted");
                        $(self.renderer).off("DisplayControllerElementError");
												self.playlist.renderer.cancel_all(self.playlist.rendering.content.reference,self.renderer.default_layer,true);
                    });
                    self.scene = self.renderer.prepare_scene(false,alert_content.getId(),false);
                    self.rendering = self.renderer.render_scene(self.scene,self.rendering);
                //}
            }else{
                self.log("Unloading onScreenAlert.");
                self.playlist.renderer.cancel_all(self.alertWindowRef,self.renderer.default_layer,true);
                if(!self.playlist.active){
                    self.playlist.start();
                }
            }
        }
    };

    this.onInvalidPlaylist = function(e){
        e.currentTarget.log("Warning : Invalid Playlist !!");
        //e.currentTarget.renderer.stage.css("background","#000");
        self.notifyError(self.ERROR['PLAYER_CONTROLLER']+3,self.name+": Function onInvalidPlaylist() failed : Warning : Invalid Playlist !!",self.dataManager.getBase64XMLcopy());
    };

    this.getWeekTimestampFromFile = function(){
        clearTimeout(self.timer);
        self.OS.fileExists(self.ROUTES['XML'].path+self.ROUTES['TIMESTAMP'].path,function(exists,file_ref,params){
            if(exists){
                self.OS.readFile(self.ROUTES['XML'].path+self.ROUTES['TIMESTAMP'].path,function(data,file_ref,params){
                    self.onGetFileModificationDate(data);
                });
            }else{
                self.log("WARNING : Could not get Week Timestamp ... creating ... ");
                self.notifyError(self.ERROR['PLAYER_CONTROLLER']+4,self.name+": Function getWeekTimestampFromFile() failed : WARNING : Could not get Week Timestamp ... creating ... ");
                self.OS.writeFile(self.ROUTES['XML'].path+self.ROUTES['TIMESTAMP'].path,"1");
            }
        });

    };

    this.getWeekTimestampFromXML = function(){
        clearTimeout(self.timer);
				try{
					var url = self.getDataUrl();
					self.OS.modificationDate(url,self.onGetFileModificationDate);
	        url = null;
	        self.timer = setTimeout(self.getWeekTimestampFromXML,5000);
				}catch(e){
					self.log("Exception trying to get Modification date ... sending 0 as modification date XML timestamp");
					self.onGetFileModificationDate(new Date().getTime());
				}
    };

		this.getWeekTimestampFromXMLData = function(){
				clearTimeout(self.timer);
				try{
					$(self.dataManager).off("DataManagerControllerDataLoaded",self.onDataLoaded);
					self.dataManager.load(self.OS.rootDir+self.getDataUrl());
					self.onGetFileModificationDate(self.dataManager.getTimestamp());
					self.timer = setTimeout(self.getWeekTimestampFromXMLData,5000);
				}catch(e){
					self.log("Exception trying to get Modification date ... sending 0 as modification date XML timestamp");
				}
		};

    this.onGetFileModificationDate = function(modificationDate){
        clearTimeout(self.timer);
        if(modificationDate != "" && modificationDate != self.file_timestamp){
            self.log("XML Data modified on stamp : "+modificationDate);
            $(self.dataManager).one("DataManagerControllerDataLoaded",self.onDataLoaded);
            if(self.platform == "CHROMEOS"){
              var chrome_url = self.OS.fs.root.toURL()+self.getDataUrl();
              self.dataManager.load(chrome_url,self.file_timestamp);
						}else if(self.platform == "BRIGHT"){
							self.OS.readFile(self.getDataUrl(),function(xml_data){
								self.dataManager.loadDataXML(xml_data,self.file_timestamp);
							})
            }else{
              self.dataManager.load(self.OS.rootDir+self.getDataUrl(),self.file_timestamp);
            }
            self.file_timestamp = modificationDate;
        }else{
			clearTimeout(self.timer);
            if(self.platform == "SOC"){
                self.timer = setTimeout(self.getWeekTimestampFromFile,self.check_interval);
						}else if(self.platform == "ONLINE"){
								self.timer = setTimeout(self.getWeekTimestampFromXMLData,self.check_interval);
            }else{
                self.timer = setTimeout(self.getWeekTimestampFromXML,self.check_interval);
            }
        }
    };

    this.setUseServerTime = function(localTime,serverTime,timezoneOffset,future_change_timestamp,future_change_offset){
        var before = self.getDate().getTime();
        self.setServerTimeParams(localTime,serverTime,timezoneOffset,future_change_timestamp,future_change_offset);
        var after = self.getDate().getTime();
        $(self).trigger("SystemTimeUpdate",[before,after]);
    };


    this.keyUp = function(keyCode,shifted,ctrl){
        //self.log("KeyUp : "+keyCode);
				if(keyCode == 40){ // character: <- OR ->
					if(typeof($(".proxy-setup-window").html()) !== "undefined" || typeof($(".core-setup-window").html()) !== "undefined"){
						console.log("TAB !");
						var focused = $(document.activeElement);
						console.log("Now:"+focused.attr('tabindex'));
						var tabIndex = 0;
						if(typeof(focused.attr('id')) === "undefined"){
							tabIndex = 1;
						}else{
							tabIndex = parseInt(focused.attr('tabindex'))+1;
						}
						console.log(tabIndex);
						if(focused.attr('id') == "core-save-config-btn" || focused.attr('id') == "proxy-save-config-btn"){
							$(".input-conf[tabindex='1']").focus();
						}else{
							$(".input-conf[tabindex='"+tabIndex+"']").focus();
						}
					}
				}

				if(keyCode == 38){ // character: <- OR ->
					if(typeof($(".proxy-setup-window").html()) !== "undefined" || typeof($(".core-setup-window").html()) !== "undefined"){
						console.log("TAB !");
						var focused = $(document.activeElement);
						console.log("Now:"+focused.attr('tabindex'));
						if(typeof(focused.attr('id')) === "undefined"){
							$(".input-conf[tabindex='1']").focus();
						}else{
							var tabIndex = parseInt(focused.attr('tabindex'));
							if(tabIndex > 1){
								tabIndex = parseInt(focused.attr('tabindex'))-1;
							}
							console.log(tabIndex);
							$(".input-conf[tabindex='"+tabIndex+"']").focus();
						}
					}
				}

				if(keyCode == 32 || keyCode == 13){ // character: <- OR ->
					if(typeof($(".proxy-setup-window").html()) !== "undefined" || typeof($(".core-setup-window").html()) !== "undefined"){
						$(document.activeElement).click();
					}
				}
    }

    this.keyDown = function(keyCode,shifted,ctrl){
        self.log("KeyDown :"+keyCode);
        if(keyCode == 27){  // character: ESC
            self.OS.quit(shifted,ctrl);
        }

				if(keyCode == 81 && shifted && ctrl){  // character: Q
            self.OS.quit(shifted,ctrl);
        }

				if(keyCode == 80 && shifted && ctrl){  // character: P
						if(self.platform == "WIN" || self.platform == "MAC" || self.platform == "LINUX"){
							self.toggleProxySetupWindow();
							self.setMouseCursor('auto');
						}
        }

				if(keyCode == 67 && shifted && ctrl){  // character: C
					if(self.platform !== "WEB"){
						self.toggleCoreSetupWindow();
						/*
						if(self.platform == "TIZEN" || self.platform == "WEBOS"){
							$("#core-reg").css('visibility','visible');
						}
						*/
						self.setMouseCursor('auto');
					}else{
						self.userInterface.toggle();
						self.renderer.checkUi(self.playlist.rendering.content.reference);
					}
				}

				if(keyCode == 76 && shifted && ctrl) { // character: L
						if(self.registered){
								self.log("Activate logger ... "+self.debug);
								self.debug = !self.debug;
								if(typeof(self.logger) !== 'undefined'){
										self.setLogger(self.log_window);
								}else{
										self.logger = null;
								}
								self.activateLogger(self.debug);
						}
				}
				if(keyCode == 68 && shifted && ctrl) { // character: D
						if(self.registered){
								self.log("Activate debugger ... "+self.debug);
								self.debug = !self.debug;
								self.activateLogger(self.debug);

						}
				}
				if(keyCode == 85 && shifted && ctrl){ // character: U
						if(self.registered){
								self.update();
						}
				}

				if(keyCode == 82 && shifted && ctrl){ // character: R
					if(typeof($(".core-setup-window").html()) !== "undefined"){
						if($("#core-reg").css('visibility') == "hidden"){
							$("#core-reg").css('visibility','visible');
						}else{
							$("#core-reg").css('visibility','hidden');
						}
					}
				}


				if(keyCode == 69 && shifted && ctrl){ // character: E
						// SIMULATE ERROR
						self.log("Simulate Error ");
						self.notifyError(1,"Simulate Error");

				}
				if(keyCode == 83 && shifted && ctrl){ // character: S
					try{
						if(self.volume == 0){
							self.setVolume(self.config.getVolume());
						}else{
							self.setVolume(0);
						}
					}catch(e){
						console.log(e);
					}
				}


    };

		this.toggleProxySetupWindow = function(){
			console.log("Setup Proxy ....");
			if(typeof($(".proxy-setup-window").html()) !== "undefined"){
				$(".proxy-setup-window").remove();
				$(".ui-main").hide();
				self.proxy_setup_window_showing = false;
			}else{
				self.proxy_setup_window_showing = true;
				var certs = [];
				var directory = "";
				if(self.platform !== "TIZEN" && self.platform !== "WEBOS"){directory = "./";}
				self.OS.readDirectory(directory,function(list){
					for(var i=0;i<list.length;i++){
						var ext = list[i].substring(list[i].lastIndexOf("."),list[i].length);
						if(ext == ".pem" || ext == ".crt"){
							console.log("Found Cert : "+list[i]);
							certs.push(list[i]);
						}
					}
					self.OS.readFile(self.ROUTES['PROXY_CONF'].path,function(data){
						var hostname = "";
						var port = "";
						var username = "";
						var password = "";
						var local_hostname = "127.0.0.1";
						var local_port = "9090";
						var protocol = "http";
						var cert_file = "";
						var ignore_cert = true;
						if(data !== ""){
							var reverse_proxy_conf = false;
							try{
								reverse_proxy_conf = JSON.parse(data);
								hostname = reverse_proxy_conf.remote_host;
								port = reverse_proxy_conf.remote_port;
								username = reverse_proxy_conf.usr;
								password = reverse_proxy_conf.pwd;
								local_hostname = reverse_proxy_conf.local_host;
								local_port = reverse_proxy_conf.local_port;
								protocol = reverse_proxy_conf.force_download_protocol;
								cert_file = reverse_proxy_conf.cert_file;
								ignore_cert = reverse_proxy_conf.ignore_https_cert;
							}catch(e){
								self.log("NOT USING PROXY ---- No Valid Proxy Config found : ");
							}
						}
						var proxy_window_html = "<div class='proxy-setup-window' style='width:100%;height:100%;background-color:#000;opacity:80%;cursor:inherit;pointer-events:inherit'>Proxy Setup : ";
						proxy_window_html+="<p> Hostname : <input class='input-conf' id='proxy-remote-hostname' type='text' placeholder='proxy.mydomain.com' value='"+hostname+"' tabindex='1'></input>";
						proxy_window_html+="<br> Port : <input class='input-conf' id='proxy-remote-port' type='text' placeholder='8080' value='"+port+"' tabindex='2'></input>";
						proxy_window_html+="<br> User : <input class='input-conf' id='proxy-remote-user' type='text' value='"+username+"' tabindex='3'></input>";
						proxy_window_html+="<br> Password : <input class='input-conf' id='proxy-remote-pass' type='password' value='"+password+"' tabindex='4'></input>";
						proxy_window_html+="<br> (Optional) Forwarder IP : <input class='input-conf' id='proxy-local-hostname' type='text' placeholder='127.0.0.1' value='"+local_hostname+"' tabindex='5'></input>";
						proxy_window_html+="<br> (Optional) Forwarder Port : <input class='input-conf' id='proxy-local-port' type='text' placeholder='9090' value='"+local_port+"' tabindex='6'></input>";
						//proxy_window_html+="<br> Download Protocol : <input class='input-conf' id='proxy-download-protocol' type='text' value='"+protocol+"' tabindex='5'></input>";
						if(protocol == "http"){
							proxy_window_html+="<br> Download Protocol : <input type='checkbox' class='input-conf' id='proxy-download-protocol-https' name='proxy-download-protocol' tabindex='7' value='https' onChange=\"var me = this; $(\'input[name=\'+me.name+\']\').each(function(index){if($(this).attr(\'id\') !== $(me).attr(\'id\')){$(this).removeAttr(\'checked\')}});$(me).attr(\'checked\',\'checked\');\">https</input><input type='checkbox' class='input-conf' id='proxy-download-protocol-http' name='proxy-download-protocol' tabindex='8' value='http' onChange=\"var me = this; $(\'input[name=\'+me.name+\']\').each(function(index){if($(this).attr(\'id\') !== $(me).attr(\'id\')){$(this).removeAttr(\'checked\')}});$(me).attr(\'checked\',\'checked\');\" checked='checked'>http</input>";
						}else{
							proxy_window_html+="<br> Download Protocol : <input type='checkbox' class='input-conf' id='proxy-download-protocol-https' name='proxy-download-protocol' tabindex='7' value='https' onChange=\"var me = this; $(\'input[name=\'+me.name+\']\').each(function(index){if($(this).attr(\'id\') !== $(me).attr(\'id\')){$(this).removeAttr(\'checked\')}});$(me).attr(\'checked\',\'checked\');\" checked='checked'>https</input><input type='checkbox' class='input-conf' id='proxy-download-protocol-http' name='proxy-download-protocol'  tabindex='8' value='http' onChange=\"var me = this; $(\'input[name=\'+me.name+\']\').each(function(index){if($(this).attr(\'id\') !== $(me).attr(\'id\')){$(this).removeAttr(\'checked\')}});$(me).attr(\'checked\',\'checked\');\">http</input>";
						}
						if(ignore_cert){
							proxy_window_html+="<br> Ignore Certificate Errors : <input type='checkbox' class='input-conf' id='proxy-ignore-cert' name='proxy-ignore-cert' tabindex='9' value='true' onChange=\"var me = this; $(\'input[name=\'+me.name+\']\').each(function(index){if($(this).attr(\'id\') !== $(me).attr(\'id\')){$(this).removeAttr(\'checked\')}});$(me).attr(\'checked\',\'checked\');\" checked='checked'>true</input><input type='checkbox' class='input-conf' id='proxy-ignore-cert-not' name='proxy-ignore-cert' tabindex='10' value='false' onChange=\"var me = this; $(\'input[name=\'+me.name+\']\').each(function(index){if($(this).attr(\'id\') !== $(me).attr(\'id\')){$(this).removeAttr(\'checked\')}});$(me).attr(\'checked\',\'checked\');\">false</input>";
						}else{
							proxy_window_html+="<br> Ignore Certificate Errors : <input type='checkbox' class='input-conf' id='proxy-ignore-cert' name='proxy-ignore-cert' tabindex='9' value='true' onChange=\"var me = this; $(\'input[name=\'+me.name+\']\').each(function(index){if($(this).attr(\'id\') !== $(me).attr(\'id\')){$(this).removeAttr(\'checked\')}});$(me).attr(\'checked\',\'checked\');\">true</input><input type='checkbox' class='input-conf' id='proxy-ignore-cert-not' name='proxy-ignore-cert' tabindex='10' value='false' onChange=\"var me = this; $(\'input[name=\'+me.name+\']\').each(function(index){if($(this).attr(\'id\') !== $(me).attr(\'id\')){$(this).removeAttr(\'checked\')}});$(me).attr(\'checked\',\'checked\');\" checked='checked'>false</input>";
						}
						proxy_window_html+="<br> Available Certificates for Proxy:";
						proxy_window_html+="<br><input type='checkbox' class='input-conf' id='proxy-cert-file-0' name='proxy-cert-file' tabindex='11' value='' onChange=\"var me = this; $(\'input[name=\'+me.name+\']\').each(function(index){if($(this).attr(\'id\') !== $(me).attr(\'id\')){$(this).removeAttr(\'checked\')}});$(me).attr(\'checked\',\'checked\');\">NONE</input>";
						var cert_found = false;
						for(var j=0;j<certs.length;j++){
							if(certs[j]==cert_file){
								cert_found = true;
								proxy_window_html+="<br><input type='checkbox' class='input-conf' id='proxy-cert-file-"+(j+1)+"' name='proxy-cert-file' tabindex='"+(j+12)+"' value='"+certs[j]+"' onChange=\"var me = this; $(\'input[name=\'+me.name+\']\').each(function(index){if($(this).attr(\'id\') !== $(me).attr(\'id\')){$(this).removeAttr(\'checked\')}});$(me).attr(\'checked\',\'checked\');\" checked='checked'>"+certs[j]+"</input>";
							}else{
								proxy_window_html+="<br><input type='checkbox' class='input-conf' id='proxy-cert-file-"+(j+1)+"' name='proxy-cert-file' tabindex='"+(j+12)+"' value='"+certs[j]+"' onChange=\"var me = this; $(\'input[name=\'+me.name+\']\').each(function(index){if($(this).attr(\'id\') !== $(me).attr(\'id\')){$(this).removeAttr(\'checked\')}});$(me).attr(\'checked\',\'checked\');\">"+certs[j]+"</input>";
							}
						}
						proxy_window_html+="</p><p id='proxy-result'></p>";
						proxy_window_html+="<button class='input-conf' id='proxy-save-config-btn' tabindex='"+(j+12)+"'>Save</button>";
						proxy_window_html+="</div>";
						$(".ui-main").append($(proxy_window_html));
						if(!cert_found){$("#proxy-cert-file-0").click();}
						$("#proxy-setup-window").focus();
						$(".input-conf[tabindex='1']").focus();
						$(".input-conf[tabindex='1']").select();
						$("#proxy-save-config-btn").on("click",function(e){
							var use_https = false;
							var ignore_https_cert = false;
							var forced_protocol = "http";
							if(typeof($("#proxy-download-protocol-https").attr('checked')) !== 'undefined'){
								if($("#proxy-download-protocol-https").attr('checked') == "checked"){
									use_https = true;
									forced_protocol = "https";
								}
							}
							if(typeof($("#proxy-ignore-cert").attr('checked')) !== 'undefined'){
								if($("#proxy-ignore-cert").attr('checked') == "checked"){
									ignore_https_cert = true;
								}
							}
							var cert_file = "";
							$("input[name='proxy-cert-file']").each(function(index){
								if(typeof($(this).attr('checked')) !== 'undefined'){
									if($(this).attr('checked') == "checked"){
										cert_file = $(this).val();
									}
								}
							});
							console.log(cert_file);
							var new_proxy_conf =  {
							  "local_host" : ""+$("#proxy-local-hostname").val(),
							  "local_port" : parseInt($("#proxy-local-port").val()),
							  "remote_host" : ""+$("#proxy-remote-hostname").val(),
							  "remote_port": parseInt($("#proxy-remote-port").val()),
							  "usr" : ""+$("#proxy-remote-user").val(),
							  "pwd": ""+$("#proxy-remote-pass").val(),
							  "is_remote_https" : use_https,
							  "ignore_https_cert" : ignore_https_cert,
							  "are_remotes_in_pac_https" : false,
								"force_download_protocol": forced_protocol,
								"cert_file":cert_file
							 };
							 var config_data = JSON.stringify(new_proxy_conf);
							 if($("#proxy-remote-hostname").val() == ""){
								 config_data = "";
							 }
							 self.OS.writeFile(self.ROUTES['PROXY_CONF'].path,config_data,function(ok){
								 if(ok){
									 $("#proxy-result").css('color','green');
									 $("#proxy-result").html("Saved - Please restart the player for the configuration to take effect.");
									 setTimeout(function(){$("#proxy-result").html("")},5000);
								}else{
									$("#proxy-result").css('color','red');
									$("#proxy-result").html("Failed");
								}
							 });
						})
						$(".ui-main").show();
					});
				});
			}
		};



		this.toggleCoreSetupWindow = function(){
			console.log("Setup Core ....");
			if(typeof($(".core-setup-window").html()) !== "undefined"){
				$(".core-setup-window").remove();
				$(".ui-main").hide();
				self.core_setup_window_showing = false;
			}else{
				self.core_setup_window_showing = true;
				self.OS.readFile(self.ROUTES['CORE'].path,function(data){
					var url = "apilb.admira.com";
					//var url_protocol = "https";
					var server_url = "apilb.admira.com";
					//var server_protocol = "https";
					var autoreg = "0";
					var api_ver = "3.0";
					if(data !== ""){
						try{
								var parser=new DOMParser();
								var xmlDoc=parser.parseFromString(data,"text/xml");
								/*
								url = xmlDoc.getElementsByTagName("api_url")[0].childNodes[0].nodeValue;
								try{
									url_protocol = xmlDoc.getElementsByTagName("protocol")[0].childNodes[0].nodeValue;
								}catch(e){
									console.log("No protocol set for URL protocol ... asssuming HTTPS");
								}
								*/
								server_url = xmlDoc.getElementsByTagName("server")[0].getAttribute('url');
								/*
								try{
									server_protocol = xmlDoc.getElementsByTagName("server")[0].getAttribute('protocol');
									if(server_protocol == null){server_protocol="https";}
								}catch(e){
									console.log("No protocol set for Server URL protocol ... asssuming HTTPS");
								}
								*/
								api_ver = ""+xmlDoc.getElementsByTagName("api_ver")[0].childNodes[0].nodeValue;
								try{
									autoreg = xmlDoc.getElementsByTagName("autoreg")[0].childNodes[0].nodeValue;
									if(autoreg === null){autoreg = "0";}
								}catch(e){
									console.log("No autoregister found");
								}
						}catch(e){
								self.log(e);
						}
					}
					 var info = self.config.getPlayerInfo();
					var core_window_html = "<div class='core-setup-window' style='width:100%;height:100%;background-color:#000;opacity:80%;cursor:inherit;pointer-events:inherit'><p id='core-info'>Core Setup : <br>ID = <b>"+self.core_id+"</b> <br>API KEY = <b>"+info.api_key+"</b></p>";
					core_window_html+="<p> Server : <input class='input-conf' id='core-remote-hostname' type='text' placeholder='apilb.admira.com' value='"+url+"' tabindex='1'></input>";
					core_window_html+="<br> Fallback Server List: <input class='input-conf' id='core-remote-hostname-list' type='text' placeholder=a.example.com,b.example.com' value='' size='80' tabindex='2'></input>";
					core_window_html+="<br> Download Server : <input class='input-conf' id='core-remote-server' type='text' placeholder='apilb.admira.com' value='"+server_url+"' tabindex='3'></input>";
					core_window_html+="<br> API Version : <input class='input-conf' id='core-remote-api-ver' type='text' value='"+api_ver+"' tabindex='4'></input>";
					core_window_html+="<br> <span style='visibility:hidden' id='core-reg'>Register Project ID: <input class='input-conf' id='core-remote-autoreg' type='text' value='"+autoreg+"' tabindex='5' onKeyDown='$(\"#core-result\").css(\"color\",\"orange\");$(\"#core-result\").html(\"Warning : Register info has changed ... Player will need to reload and re-register in order to take effect.\")'></input></span>";
					core_window_html+="</p><p id='core-result'></p>";
					core_window_html+="<button class='input-conf' id='core-save-config-btn' tabindex='6'>Save</button>";
					core_window_html+="</div>";
					var api_server_list = {
	                id: "api_server_list",
	                player:0,
	                name: "TransferService"
	            };
	        self.getStatusFile(api_server_list,function(data,params){
	            if(typeof(data) !== "undefined"){
	                if(typeof(data.list) !== "undefined"){
										$("#core-remote-hostname-list").val(data.list);
	                }
	            }
	        });
					$(".ui-main").append($(core_window_html));
					$("#core-setup-window").focus();
					$(".input-conf[tabindex='1']").focus();
					$(".input-conf[tabindex='1']").select();
					$("#core-save-config-btn").on("click",function(e){

						var new_autoreg = $("#core-remote-autoreg").val();
						var actual_core_id = self.core_id;
						if(new_autoreg !== autoreg){
							actual_core_id = "0";
							$("#core-info").html("");
						}
						var core_xml = '<?xml version="1.0" encoding="utf-8" ?>';
						core_xml += '<core>';
						core_xml += '<config>';
						core_xml += '<id>'+actual_core_id+'</id>';
						core_xml += '<autoreg>'+$("#core-remote-autoreg").val()+'</autoreg>';
						core_xml += '<api_ver>'+$("#core-remote-api-ver").val()+'</api_ver>';
						core_xml += '<api_url>'+$("#core-remote-hostname").val()+'</api_url>';
						//core_xml += '<protocol>'+$("#core-remote-hostname-protocol").val()+'</protocol>';
						core_xml += '</config>';
						//core_xml += '<server url="'+$("#core-remote-server").val()+'" protocol="'+$("#core-download-protocol").val()+'"/>';
						core_xml += '<server url="'+$("#core-remote-server").val()+'"/>';
						core_xml += '</core>';

						 self.OS.writeFile(self.ROUTES['CORE'].path,core_xml,function(ok){
							 if(ok){
								 if(new_autoreg !== autoreg){
									 self.log("New Autoregister found !! ... restarting registration");
									 var xml_data = '<?xml version="1.0"?><admira timestamp="1" version="1.0" status="ok"><archive/><playlist><loop/></playlist><screens /><config volume="100" fullscreen="true" mode="1" always_on_top="true" plv_name="Debug Name" project_name="Debug Project" time="30" plv_id="0" quit_on_click="true" activated="false" domain="" api_key="" live_url="" live_recheck_seconds="" live_send_id=""><resolution x="100" y="100" width="300" height="300" /></config></admira>';
									 self.OS.writeFile(self.ROUTES['XML'].path+self.getDayOfWeek()+".xml",xml_data,function(ok){
										 if(ok){
											 self.OS.deleteFile(self.ROUTES['LICENSE'].path,function(ok){
												 if(ok){
													 self.log("Re-registering");
													 self.OS.reload();
												 }else{
													 self.log("Re-registering failed !! ");
												 }
											 });
										 }else{
											 self.log("Something went wrong trying to safe new data");
										 }
									 });
									 $("#core-result").css('color','orange');
									 $("#core-result").html("Saved - Please restart the player for the configuration to take effect.<br> Player will try to Auto-Register ...");
								 }else{
									 $("#core-result").css('color','green');
									 $("#core-result").html("Saved - Please restart the player for the configuration to take effect.");
								 }
								 setTimeout(function(){$("#core-result").html("")},5000);
								 if($("#core-remote-hostname-list").val() !== ""){
									 var api_server_list = {
					             id: "api_server_list",
					             player:0,
					             name: "TransferService",
					             list : $("#core-remote-hostname-list").val().split(',')
					         };
					         self.saveStatusFile(api_server_list);
								 }
							}else{
								$("#core-result").css('color','red');
								$("#core-result").html("Failed");
							}
						 });
					})
					$(".ui-main").show();
				});
			}
		};

    this.keyPress = function(keyCode,shifted,ctrl){

			var character = String.fromCharCode(keyCode);


        if(self.playlist.conditional){
            var timestamp = parseInt(self.getDate().getTime()/1000);
            var condition = {
                'id': 29,
                'filename':'keyboard.xml',
                'tstamp':timestamp,
                'version':'1.0',
                'status':'ok',
                'value':character,
								'broadcast':false
            };
            self.playlist.conditional.onNewConditionValue(condition,false);  // Use true to write condition file
        }
    }

		this.getInfo = function(){
			var stats_type = 0;
			try{
				stats_type = self.dataManager.getStats().getStatType()
			}catch(e){
				console.log("getInfo : Could not get stats type ");
			}
			var info = {player_id: self.core_id, platform: self.platform, stats_type:stats_type,api_url:self.api_url,api_server_url:self.api_server_url};
			if(typeof(self.playlist) !== "undefined"){
				if(self.playlist){
					info[''+self.playlist.name] = null;
					info[''+self.playlist.name] = self.playlist.getInfo();
				}
				if(typeof(self.playlist.synchronizer) !== "undefined"){
					if(self.playlist.synchronizer){
						info[''+self.playlist.synchronizer.name] = null;
						info[''+self.playlist.synchronizer.name] = self.playlist.synchronizer.getInfo();
					}
				}
				if(typeof(self.renderer) !== "undefined"){
					if(self.renderer){
						info[''+self.renderer.name] = null;
						info[''+self.renderer.name] = self.renderer.getInfo();
					}
				}
				if(typeof(self.OS) !== "undefined"){
					info['OperatingSystemController'] = null;
					info['OperatingSystemController'] = self.OS.getInfo();
				}
				try{
					if(typeof(self.api_connector) !== "undefined"){
						info[''+self.api_connector.name] = null;
						info[''+self.api_connector.name] = self.api_connector.getInfo();
					}
				}catch(e){
					self.log("Could not read api options on ApiConnector")
				}

				try{
					if(!self.is_child){
						if(typeof(window.opener) !== "undefined"){
								if(typeof(exportChildrenInfo) !== "undefined"){
									info['OperatingSystemController'].children = exportChildrenInfo;
								}
						}
					}else{
						if(typeof(window.opener) !== "undefined"){
								window.opener.setExportChildrenInfo(self.player_id,info);
						}
					}
				}catch(e){
					console.log("window.opener not found");
				}
			}
			return info;
		};

    this.onApiContentConditionSet = function(e,command){
        if(self.playlist.conditional){
            if(typeof(command.params) !== "undefined"){
                if(typeof(command.params.id) !== "undefined"
                   && typeof(command.params.filename) !== "undefined"
                   && typeof(command.params.value) !== "undefined"){
                    var condition = {
                        'id': command.params.id,
                        'filename':command.params.filename,
                        'tstamp':parseInt(self.getDate().getTime()/1000),
                        'version':'1.0',
                        'status':'ok',
                        'value':command.params.value,
												'broadcast':false
                    };
										var write = true;
										if(typeof(command.params.write) !== "undefined"){
											write = Boolean(command.params.write);
										}
										self.playlist.conditional.onNewConditionValue(condition,write);  // Use true to write condition file
                }else{
                    self.notifyError(self.ERROR['PLAYER_CONTROLLER']+5,self.name+": Function onApiContentConditionSet() failed : not enough condition data");
                }
            }else{
                self.notifyError(self.ERROR['PLAYER_CONTROLLER']+5,self.name+": Function onApiContentConditionSet() failed : not valid condition data");
            }
        }else{
            self.notifyError(self.ERROR['PLAYER_CONTROLLER']+5,self.name+": Function onApiContentConditionSet() failed : not valid condition data");
        }
    };

    this.onApiContentWriteFile = function(e,command,client,origin){
        if(typeof(command.params) !== "undefined"){
            if(typeof(command.params.path) !== "undefined"
               && typeof(command.params.filename) !== "undefined"
               && typeof(command.params.text) !== "undefined"){
                if(command.params.path[command.params.path.length-1] != "/"){
                    command.params.path += "/";
                }
                self.OS.writeFile(command.params.path+command.params.filename,command.params.text,function(ok,file_ref){
									try{
										var response = {
											file_ref: file_ref,
											data:{written:true},
											callback: command.params.callback
										}
										self.content_api.sendApiContentEvent(client,self.content_api.API_WRITE_FILE,origin,response);
									}catch(e){
											console.log("onApiContentWriteFile : No Callback Found ... avoid");
									}
								});
            }else{
                self.notifyError(self.ERROR['PLAYER_CONTROLLER']+6,self.name+": Function onApiContentWriteFile() failed : not enough condition data");
            }
        }else{
            self.notifyError(self.ERROR['PLAYER_CONTROLLER']+6,self.name+": Function onApiContentWriteFile() failed : not valid file data");
        }
    };

		this.onApiContentReadFile = function(e,command,client,origin){
				if(typeof(command.params) !== "undefined"){
						if(typeof(command.params.path) !== "undefined"
							 && typeof(command.params.filename) !== "undefined"
						 	 && typeof(command.params.callback) !== "undefined"){
								if(command.params.path[command.params.path.length-1] != "/"){
										command.params.path += "/";
								}
								var read_file = true;
								if(typeof(command.params.check_exists) !== "undefined"){
									if(command.params.check_exists){
											read_file = false;
											self.OS.fileExists(command.params.path+command.params.filename,function(exists,file_ref,params){
													var response = {
														file_ref: file_ref,
														data:{check_file:true,exists:exists},
														callback: command.params.callback
													}
													self.content_api.sendApiContentEvent(client,self.content_api.API_READ_FILE,origin,response);
											});
									}
								}
								if(read_file){
									self.OS.readFile(command.params.path+command.params.filename,function(data,file_ref,params){
											var response = {
												file_ref: file_ref,
												data:data,
												callback: command.params.callback
											}
											self.content_api.sendApiContentEvent(client,self.content_api.API_READ_FILE,origin,response);
									});
								}
						}else{
								self.notifyError(self.ERROR['PLAYER_CONTROLLER']+8,self.name+": Function onApiContentReadFile() failed : not enough api data");
						}
				}else{
						self.notifyError(self.ERROR['PLAYER_CONTROLLER']+8,self.name+": Function onApiContentReadFile() failed : not valid file data");
				}
		};

    this.onApiContentAnalytic = function(e,command){
        if(typeof(command.params) !== "undefined"){
            if(typeof(command.params.path) !== "undefined"
               && typeof(command.params.extension) !== "undefined"
               && typeof(command.params.json) !== "undefined"){
                var timestamp = parseInt(self.getDate().getTime()/1000);
                if(command.params.path[command.params.path.length-1] != "/"){
                    command.params.path += "/";
                }
                var path = command.params.path+self.core_id+"_"+timestamp+command.params.extension;
                self.OS.writeFile(path,JSON.stringify(command.params.json));
            }else{
                self.notifyError(self.ERROR['PLAYER_CONTROLLER']+7,self.name+": Function onApiContentAnalytic() failed : not enough condition data");
            }
        }else{
            self.notifyError(self.ERROR['PLAYER_CONTROLLER']+7,self.name+": Function onApiContentAnalytic() failed : not valid file data");
        }
    };


		this.onApiContentGetPlayerInfo = function(e,command,client,origin){
			if(typeof(command.params) !== "undefined"){
					if(typeof(command.params.callback) !== "undefined"){
						try{
							self.content_api.updateInfo(self.name,self.getInfo());
						}catch(e){
							self.log("Expection : Could not update CONTENT API INFO");
						}
						var response = {
							data:self.content_api.info,
							callback: command.params.callback
						}
						self.content_api.sendApiContentEvent(client,self.content_api.API_PLAYER_INFO,origin,response);
					}
			}
		};

		this.onApiContentPreloadNext = function(e,command){
			try{
				if(self.playlist.name == "PlaylistController"){
					self.log("$$$ Preload jumps : "+self.playlist.preload_jumps);
					if(self.playlist.preload_jumps <= self.playlist.elements.length){
						self.playlist.index = self.playlist.next_index;
						self.playlist.checknext(1,true);
						self.playlist.preload_jumps++;
					}else{
						self.playlist.contentToBeRendered = self.renderer.getDefaultDisplayReference();
						self.playlist.templateToBeRendered = false;
						self.playlist.scene = self.renderer.prepare_scene(self.playlist.templateToBeRendered,self.playlist.contentToBeRendered,true);
					}
				}else{
					self.log("Can not DO : onApiContentPreloadNext() ... you are on Timeline Mode");
				}
			}catch(e){
					self.log("Exception on : onApiContentPreloadNext()");
			}
		};

		this.onApiContentAppQuit = function(e,command){
			try{
				self.OS.quit();
			}catch(e){
				self.log("onApiContentAppQuit: Could not quit App");
			}
		};

    this.onApiContentMainDuration = function(e,command){
        if(typeof(command.params) !== "undefined"){
            if(typeof(command.params.duration) !== "undefined" ){
                var element = self.renderer.getDisplayContentElement(self.playlist.rendering.content.reference);
                element.controller[element.active_switcher].onApiChangeDuration(e,command);
            }
        }
    };

		this.onApiContentSetVolume = function(e,command){
        if(typeof(command.params) !== "undefined"){
            if(typeof(command.params.volume) !== "undefined" ){
								var new_volume = parseFloat(command.params.volume)/100;
								self.api_content_volume = new_volume;
								self.setVolume(new_volume);
            }
        }
    };

		this.onApiContentSetPlayStatus = function(e,command){
        if(typeof(command.params) !== "undefined"){
          if(typeof(command.params.enable) !== "undefined" ){
						if(typeof(command.params.enable) == "boolean"){
							if(self.playlist.enable != command.params.enable){
								self.renderer.clear();
								if(command.params.enable){
                  self.playlist.start();
								}else{
									self.playlist.stop();
								}
							}
						}
          }
        }
    };


		this.onApiContentDeleteFile = function(e,command,client,origin){
			var response = {
				status:"error",
				data:"unknown",
				callback:"undefined"
			}
			try{
				if(typeof(command.params) !== "undefined"){
					if(typeof(command.params.path) !== "undefined" && typeof(command.params.filename) !== "undefined"&& typeof(command.params.callback) !== "undefined"){
							response.callback = command.params.callback;
							if(command.params.path[command.params.path.length-1] != "/"){
									command.params.path += "/";
							}
						 self.OS.deleteFile(command.params.path+command.params.filename,function(ok,file_ref,params){
									 response.file_ref = file_ref;
									 response.data = {'deleted':ok};
									 self.content_api.sendApiContentEvent(client,self.content_api.API_DELETE_FILE,origin,response);
						 });
					}else{
						response.data = "incorrect params";
						self.content_api.sendApiContentEvent(client,self.content_api.API_DELETE_FILE,origin,response);
					}
        }else{
					response.data = "no params";
					self.content_api.sendApiContentEvent(client,self.content_api.API_DELETE_FILE,origin,response);
				}
			}catch(e){
				self.log("Exception on : onApiContentDeleteFile  = "+JSON.stringify(e));
				response.data = e;
				self.content_api.sendApiContentEvent(client,self.content_api.API_DELETE_FILE,origin,response);
			}
		};

		this.onApiContentOsFunction = function(e,command,client,origin){
			var response = {
				status:"error",
				data:"unknown",
				callback:"undefined"
			}
			try{
				if(typeof(command.params) !== "undefined"){
					if(typeof(command.params.function_name) !== "undefined" && typeof(command.params.params) !== "undefined" && typeof(command.params.callback) !== "undefined"){
						response.callback = command.params.callback;
						try{
							var inner_callback = function(data){
								response.status = "ok";
								response.data = data;
								self.content_api.sendApiContentEvent(client,self.content_api.API_OS_FUNCTION,origin,response);
							};
							var result = "";
							if(command.params.params.length == 3){
								result = self.OS[''+command.params.function_name](command.params.params[0],command.params.params[1],command.params.params[2],inner_callback);
							}else if(command.params.params.length == 2){
								result = self.OS[''+command.params.function_name](command.params.params[0],command.params.params[1],inner_callback);
							}else if(command.params.params.length == 1){
								result = self.OS[''+command.params.function_name](command.params.params[0],inner_callback);
							}else{
								result = self.OS[''+command.params.function_name](inner_callback);
							}
						}catch(e){
							self.log("Exception on : self.OS[''"+command.params.function_name+"]() with "+command.params.params.length+" params = "+JSON.stringify(e));
							response.data = e;
							self.content_api.sendApiContentEvent(client,self.content_api.API_OS_FUNCTION,origin,response);
						}
					}else{
						response.data = "incorrect params";
						self.content_api.sendApiContentEvent(client,self.content_api.API_OS_FUNCTION,origin,response);
					}
				}else{
					response.data = "no params";
					self.content_api.sendApiContentEvent(client,self.content_api.API_OS_FUNCTION,origin,response);
				}
			}catch(e){
				self.log("Exception on : ApiContentOsFunction  = "+JSON.stringify(e));
				response.data = e;
				self.content_api.sendApiContentEvent(client,self.content_api.API_OS_FUNCTION,origin,response);
			}
		};

		this.onApiContentGetVolume = function(e,command,client,origin){
			if(typeof(command.params) !== "undefined"){
					if(typeof(command.params.callback) !== "undefined"){
						var volumeSend = null;
						try{
							if(self.api_content_volume < 0){
								if(self.socket_volume < 0){
									volumeSend = self.config.getVolume();
								}
								else{
									volumeSend = self.socket_volume;
								}
							}else{
								volumeSend = self.api_content_volume;
							}
						}catch(e){
							self.log("Expection : Could not get volume API_GET_VOLUME");
						}
						var response = {
							volume:volumeSend,
							callback: command.params.callback
						}
						self.content_api.sendApiContentEvent(client,self.content_api.API_GET_VOLUME,origin,response);
					}
			}
		};

		this.onSocketSetVolume = function(e,value){
				if(typeof(value) !== "undefined"){
					var new_volume = parseFloat(value)/100;
					self.socket_volume = new_volume;
					self.setVolume(new_volume);
				}
		};


		this.onApiContentSetAudioConfig = function(e, command){
			if(typeof(command.params) !== "undefined"){
				if(typeof(command.params.model) !== "undefined"){
					try{
						self.updateAudioController(false);
						self.playlist.rendering.content.controller[self.playlist.rendering.content.active_switcher].setAudio(command.params.options);
					}catch(e){
							console.log("no useAudioController available for this OS");
					}
				}
			}
		}

		this.onSystemControllerConnectionChange = function(e){
			if(self.content_api){
				try{
					self.content_api.updateInfo(self.name,self.getInfo());
				}catch(e){
					self.log("Expection : Could not update CONTENT API INFO");
				}
				self.content_api.broadcastApiContentEvent(self.content_api.API_PLAYER_INFO,self.getInfo());
			}
		};

		this.setMouseCursor = function(value){
			$('.stage').css('cursor', value);
			$('body').css('cursor', value);
			$('.player-media').css('cursor', value);
			$('.ui-main').css('cursor', value);
			$('.ui-main').css('pointer-events', value);
		};

    this.service = function(){
        if(self.registered){
						if(self.config){
							if(self.config.getAlwaysOnTop()){
	                self.OS.focusWindow();
	            }
						}
            self.OS.keepAwake(self.platform);
        }
				if(self.platform == "WIN" || self.platform == "LINUX" || self.platform == "MAC" || self.platform == "ANDROID"){
					if($('.ui-main').css('display') === "block"){
						self.setMouseCursor('auto');
					}else{
						self.setMouseCursor('none');
					}
				}
				try{
					self.getMediaDevices(function(audio_devices){
						self.OS.audio_devices = audio_devices;
					});
				}catch(e){
					self.log("Could not get Media Devices");
				}
    };

	this.onApiContentSendLog = function(e,command,client,origin){
		if(typeof(command.params) !== "undefined"){
			self.log("APICONTENT LOG: " + command.params);
		}
	};
	this.onApiContentSendNotify = function(e,command,client,origin){
		if(typeof(command.params) !== "undefined"){
			self.log("APICONTENT LOG: " + command.params)
			self.notifyError(self.ERROR['PLAYER_CONTROLLER']+(100+Math.floor(Math.random() * 100)),"ApiContent LOG:"+command.params);
		}
	};

    if(typeof(window) !== "undefined"){
        $(window).bind("mousedown mouseup click scroll mousemove touchstart touchend",function(e){
            $(window).trigger("UserActivity");
						if(e.type == "mouseup" || e.type == "mousemove"){
                if(self.config){
										if(self.config.getQuitOnClick() && self.registered && e.type == "mouseup"){
                        self.OS.quit();
                    }else if(self.config.getQuitOnClick() && self.registered && e.type == "mousemove" && self.config.getMode() == 1){
											self.OS.quit();
										}
                }
            }else{
                /* ------------ Mouse Condition Values  ------------
                    CLICK : String = "click"
                    MOUSE_DOWN : String = "mouseDown"
                    MOUSE_UP : String = "mouseUp"
                    MIDDLE_CLICK : String = "middleClick"
                    MIDDLE_MOUSE_DOWN : String = "middleMouseDown"
                    MIDDLE_MOUSE_UP : String = "middleMouseUp"
                    RIGHT_CLICK : String = "rightClick"
                    RIGHT_MOUSE_DOWN : String = "rightMouseDown"
                    RIGHT_MOUSE_UP : String = "rightMouseUp"
                */
                // Attention : values are lower case valid only
                if(self.playlist.conditional){
                    var timestamp = parseInt(self.getDate().getTime()/1000);

                    var mouse_value = "";
                    switch(e.which){
                        case 1: // LEFT
                            mouse_value = "left";
                        break;
                        case 2: // MIDDLE
                            mouse_value = "middle";
                        break;
                        case 3: // RIGHT
                            mouse_value = "right";
                        break;

                    }
                    mouse_value += e.type;
                    var condition = {
                        'id': 30,
                        'filename':'mouse.xml',
                        'tstamp':timestamp,
                        'version':'1.0',
                        'status':'ok',
                        'value':mouse_value,
												'broadcast':false
                    };
                    self.playlist.conditional.onNewConditionValue(condition,false); // Use true to write condition file
                }
            }
        });
    }
}
PlayerController.prototype = new SystemController();
